思路:
排序,数组有序后若有满足题意的数字,则其一定在数组的中间位置。
时间复杂度O(nlogn),空间复杂度O(logn)
class Solution { public int majorityElement(int[] nums) { Arrays.sort(nums); return nums[nums.length/2]; } }
看了题解之后发现了几个更好的解题思路:
1. HashMap
遍历数组 nums,用 HashMap 统计各数字的数量,最终超过数组长度一半的数字则为众数
时间复杂度O(n),空间复杂度O(n)
//HashMap方法:不是双百解法,但是容易理解,且普适性强,并考虑了数组中不存在满足条件的众数和数组为空的情况 public int majorityElement(int[] nums) { HashMap<Integer,Integer> map = new HashMap<>(); int length = nums.length/2; for(int i=0;i<nums.length;i++){ if(map.containsKey(nums[i])) { //这里不能直接map.get(nums[i])++; map.put(nums[i],map.get(nums[i])+1); }else{ map.put(nums[i],1); } //注意:这里if不能放在第一个if中,否则会在数组长度为1时出错,无法返回正确的nums[i]的值 //这里i>=length,之所以带等号,也是为了满足长度为1的情况,因为i从0开始 //按照题目要求,必须众数次数超过长度的一半,则有第一个判断条件,相当于剪枝,当然下面的第一个判断条件也可以不加 if(i>=length&&map.get(nums[i])>length) return nums[i]; } return 0;//当不存在满足要求的数字或者数组长度为0时 } 链接:https://leetcode-cn.com/problems/shu-zu-zhong-chu-xian-ci-shu-chao-guo-yi-ban-de-shu-zi-lcof/solution/javashi-xian-hashmapjie-fa-zhi-guan-pu-gua-xing-qi/
2. 摩尔投票法
核心思想是票数正负抵消,不同的两者一旦遇见就同归于尽,最后剩下来的值都是相同的,即要求的结果。
时间复杂度O(n),空间复杂度O(1)
class Solution { public: int majorityElement(vector<int>& nums) { int res = 0, count = 0; for(int i = 0; i < nums.size(); i++){ if(count == 0){ res = nums[i]; count++; } else res==nums[i] ? count++:count--; } return res; } };